const LEN_BUFFER=1048576; //1 MB, delka bufferu pro prenaseni souboru pres WiFi
                          //po castech. nanoHttp v mobilu zvlada max cca 11 KB
                          //v datech k POST pozadavku a asi 64 MB jako prilohu
                          //v datech k POST pozadavku (je otazka, zda v kazdem
                          //mobilu), proto vsechna data prenasime jako prilohu
                          //a jeste dlouhe soubory segmentujeme po 1MB kroku.

function Ping:boolean;
var response: String;
begin
  Result:=false;
  frmMain_memoLog.Lines.Add('Ping: start');
  if(IsIp(true)) then begin
    HttpAsk('GET', GetFceUrl('ping'), '', '', response);
    Result:=(response='ok');
    IsConnected(response);
    frmMain_memoLog.Lines.Add('Ping: '+response);
  end;
end; 

// Posle soubor pripojeny k POST pozadavku
procedure SendFileWiFi(sPathFilename,sTrgDir,sFilename:string);
var response,sStart,sEnd,sUrl,sText,sPomFile:string;
    sBuffer:ansistring;
    fr:TFileStream;
    n,iOffset,iMax,nStartSec,nSec,nMin:integer;
    bEnd:boolean;
    eSec:extended;
begin
  {$ifdef DEBUG_HELPER} LDH('SendFileWiFi: start'); {$endif}
  if(not FileExists(sPathFilename)) then begin
    ShowMessage(_('ERR: File to send not found!')+CRLF+CRLF+sPathFilename);
    exit;
  end;
  frmMain_memoLog.Lines.Add('SendFileWiFi: start');
  if(sFilename='') then sFilename:=RegexSubstitute('.*\\(.*)',sPathFilename,'$1');
  if(sTrgDir<>'') then sFilename:=sTrgDir+'/'+sFileName;
  {$ifdef DEBUG_HELPER} LDH('SendFileWiFi: zdrojovy soubor: '+sPathFilename); {$endif}
  {$ifdef DEBUG_HELPER} LDH('SendFileWiFi: cilove cesta/jmeno: '+sFilename); {$endif}
  GeoBusyCaption(_('Sending file to a:Drake')+': '+sPathFilename);
  GeoBusyStart;
  GeoBusyProgress(0,3);
  sStart:='--#a1b2c3#'+CRLF+
          'Content-Disposition: form-data; name="filename"; filename="'+sFileName+'"'+CRLF+
          'Content-Type: application/octet-stream'+CRLF+CRLF;
  //{$ifdef DEBUG_HELPER} LDH('SendFileWiFi: hlavicka POST pozadavku: '+CRLF+sStart); {$endif}
  sEnd:=CRLF+'--#a1b2c3#';
  //aktualni databazi musime prekopirovat, jinak ji nemuze stream cist (divne!!)
  sPomFile:=sPathFilename;
  if(UpperCase(sPathFilename)=UpperCase(GEOGET_DATADIR+'\'+GEOGET_DBNAME+'.db3')) then begin
    GeoBusyProgress(0,3);
    GeoBusyKind(_('Creating of working copy...'));
    sPomFile:=GetMyDir()+'\tmp.tmp';
    CopyFile(sPathFilename,sPomFile);
  end;
  GeoBusyKind(_('Transfer ...'));
  //vytvorime stream pro cteni po castech
  fr:=TFileStream.Create(sPomFile,fmOpenRead or fmShareDenyWrite);
  try
    //zjistime velikost souboru a zacyklime prenos pro vsechny segmenty
    iMax:=fr.Size;
    iOffset:=0;
    bEnd:=false;
    nStartSec:=DateTimeToUnix(now);
    while((iOffset<>iMax) and (not bEnd)) do begin
      if(GeoBusyTest()) then begin bEnd:=true; continue; end;
      SetLength(sBuffer,LEN_BUFFER);
      n:=fr.Read(sBuffer,LEN_BUFFER);
      if(n=0) then begin
        ShowMessage(_('ERR: reading file error'));
        bEnd:=true;
        continue;
      end;
      if(n<LEN_BUFFER) then SetLength(sBuffer,n);
      GeoBusyProgress(iOffset,iMax);                // obsluha busy dialogu
      //odhad zbyvajiciho casu
      nSec:=DateTimeToUnix(now)-nStartSec;
      if(nSec>0) and (iOffset>0) then begin
        eSec:=(0.0+iMax-iOffset)*(0.0+nSec)/(0.0+iOffset); //pocet zbyvajicich sekund
        nMin:=Trunc(eSec/60.);
        nSec:=Trunc(eSec-60.*nMin);
        sText:=IntToStr(nMin);
        if(nMin<10) then sText:='0'+sText;
        sText:=sText+':';
        if(nSec<10) then sText:=sText+'0';
        sText:=sText+IntToStr(nSec);
        eSec:=100.*iOffset/iMax;
        sText:=IntToStr(Trunc(eSec))+' %, ETA: '+sText;
        GeoBusyKind(sText);
        {$ifdef DEBUG_HELPER} LDH('Nacteno k prenosu: '+IntToStr(n)+' B, '+sText); {$endif}
      end
      else begin
        {$ifdef DEBUG_HELPER} LDH('Nacteno k prenosu: '+IntToStr(n)+' B'); {$endif}
      end;
      //parametr offset umozni zapis na danou pozici (mineno v telefonu),
      //delka je z velikosti dat
      sUrl:=GetFceUrl('uploadfile?offset='+IntToStr(iOffset));
      if(iOffset=0) then sUrl:=sUrl+'&size='+IntToStr(iMax); //velikost pro kontrolu mista v telefonu
      //doplnime priznak konce souboru
      if(iOffset+n<iMax) then sUrl:=sUrl+'&done=false'
      else sUrl:=sUrl+'&done=true';
      {$ifdef DEBUG_HELPER} LDH('SendFileWiFi: sUrl='+sUrl); {$endif}
      HttpAsk('POST',sUrl,'multipart/form-data; boundary=#a1b2c3#',
              sStart+sBuffer+sEnd,response);
      //{$ifdef DEBUG_HELPER} LDH('response: '+response); {$endif}
      if(not IsConnected(response)) then frmMain_memoLog.Lines.Add(LOG_TAB+'SendFileWiFi: ERR');
      iOffset:=fr.Position;
      if(response='no space') then begin
        frmMain_memoLog.Lines.Add(LOG_TAB+LOG_TAB+'ERR: '+{UtfToAnsi}(response));
        response:=''; //aby doslo k oznameni chyby na konci
        break;
      end;
    end;
  finally
    fr.Free();
  end;
  if(sPomFile<>sPathFilename) then DeleteFile(sPomFile);
  if(response='') then frmMain_memoLog.Lines.Add('SendFileWiFi: ERR')
  else frmMain_memoLog.Lines.Add('SendFileWiFi: ok');
  GeoBusyProgress(0,3);
end;

procedure SendGpxFile(sFile:string; bReplace:boolean); //odesle GPX soubor, z nej a:Drake importuje kese
// Posle GPX jako soubor pripojeny k POST pozadavku
// (dat ho primo jako POST data nejde nanoHTTPD pobere jen necelych 16 kb)
// priznak bReplace je pro AD, aby pred importem kes uplna z databaze smazal
var response,sFce: String;
begin
  {$ifdef DEBUG_HELPER} LDH(LOG_TAB+'SendGpxFile: start'); {$endif}
  frmMain_memoLog.Lines.Add(LOG_TAB+'SendGpxFile: start');
  GeoBusyKind(LOG_TAB+LOG_TAB+_('Transfer ...'));
  if(bReplace) then sFce:=GetFceUrl('cache?replace=true')
  else sFce:=GetFceUrl('cache');
  HttpAsk('POST',
          sFce,
          'multipart/form-data; boundary=#a1b2c3#',
          '--#a1b2c3#' + CRLF +
          'Content-disposition: form-data; name="gpx"' + CRLF + CRLF +
          FileToString(sFile) + CRLF +
          '--#a1b2c3#',
          response);
  //odpovedi je seznam kesi a jejich WP (GC kod=jmeno) (nebo jen zmenenych?)
  frmMain_memoLog.Lines.Add(LOG_TAB+LOG_TAB+_('response')+': '+UtfToAnsi((response)));  //##_EN_##
  if(not IsConnected(response)) then frmMain_memoLog.Lines.Add(LOG_TAB+LOG_TAB+'SendGpxFile: ERR')
  else begin
    GeoBusyKind(_('Done'));
    frmMain_memoLog.Lines.Add(LOG_TAB+'SendGpxFile: ok');
  end;
end;

procedure SendGpx; //odesle soubor s kesemi tak, aby je a:Drake importoval
var sFile,sFileAll,sFileSel,s,sCaches: String;
    i,iGc,n,iWp:integer;
    g:TGeo;
    MAX_GPX_CACHES:integer;
    ini:TMemIniFile;
begin
  {$ifdef DEBUG_HELPER} LDH('SendGpx: start'); {$endif}
  frmMain_memoLog.Lines.Add('SendGpx: start');
  //nacteme maximalni pocet odesilanych kesi v jenom GPX z INI souboru
  MAX_GPX_CACHES:=0;
  sFile:=GetMyIni();
  ini:=TMemIniFile.Create(sFile);
  try
    MAX_GPX_CACHES:=ini.ReadInteger(GetPhoneName(),'SendMaxCachesInGpx',1);
  finally
    if(ini<>nil) then ini.Free();
  end;
  if(MAX_GPX_CACHES<=0) then MAX_GPX_CACHES:=1;
  GeoBusyCaption(_('Exporting caches to a:Drake'));
  sFile:=GetMyDir()+'\tmp.gpx';
  sFileAll:=GetMyDir()+'\tmp_all.ggt';
  sFileSel:=GetMyDir()+'\tmp_sel.ggt';
  {$ifdef DEBUG_HELPER} LDH('Pocet kesi k prenosu: '+IntToStr(n)+', prenasim po: '+IntToStr(MAX_GPX_CACHES)+' kesich'); {$endif}
  if(frmMain_rListGG.ItemIndex=1) then begin //odeslat jen vybrane, nevybrane smazeme ze seznamu
    s:=GetListSelected(sFileAll); //ziskame seznam vybranych kesi, zaroven ulozi seznam vsech kesi v okne do souboru
    sCaches:=s;
    StringToFile(s,sFileSel);
  end
  else begin
  {$ifdef DEBUG_HELPER} LDH('ukladam do: '+sFileAll); {$endif}
    GeoListSave(sFileAll); //ulozime vsechny kese v okne GG
    sCaches:=FileToString(sFileAll);
  end;
  //zjistime celkovy pocet kesi k prenosu
  n:=0;
  sCaches:=Trim(sCaches);
  if(sCaches='') then exit;
  sCaches:=sCaches+CRLF;
  for i:=1 to Length(sCaches) do if(sCaches[i]=Chr($0d)) then Inc(n);
  {$ifdef DEBUG_HELPER} LDH('Pocet kesi k prenosu: '+IntToStr(n)); {$endif}
  //postupne zpracujeme seznam kesi po kroku MAX_GPX_CACHES, protoze
  //  a) je omezena datova velikost, kterou lze predat pres nano-http
  //  b) je potreba se se zpracovanim a odpovedi vejit do timeoutu, ktery ma GG pro http komunikaci
  i:=0;
  g:=TGeo.Create();
  try
    while (sCaches<>'') and (IsIp(false)) and (not GeoBusyTest()) do begin  //jen pokud je co prenaset a prenos se nerozpadl
      GeoBusyKind(_('Creating GPX ...'));
      GeoListClear();
      for iGc:=1 to MAX_GPX_CACHES do begin
        if (sCaches='') then break;
        s:=Fetch(sCaches,CRLF);
        if(s<>'') then begin
          g.LoadByGC(s);
          g.ListAdd();
          Inc(i);
  {$ifdef DEBUG_HELPER} LDH('Pridavam: '+s+' ('+IntToStr(i)+'/'+IntToStr(n)+')'); {$endif}
          //ted doplnime vsechny waypointy
          for iWp:=0 to g.Waypoints.Count-1 do begin
            g.Waypoints.Items[iWp].ListAdd();
          end;
        end;
      end;
      GeoBusyProgress(i,n);
      GeoBusyKind(_('Sending GPX ...'));
      GeoExport(GEOGET_SCRIPTDIR+'\export\gpxgeoget2.gge.pas', sFile);
  {$ifdef DEBUG_HELPER} LDH('  Start prenosu'); {$endif}
      SendGpxFile(sFile,frmMain_bReplaceCache.Checked);
  {$ifdef DEBUG_HELPER} LDH('  Konec prenosu (po importu)'); {$endif}
      DeleteFile(sFile);
    end;
  finally
    g.Free();
  end;
  //vratime puvodni seznam kesi
  GeoListClear();
  GeoListFileAdd(sFileAll);
  DeleteFile(sFileAll);
  DeleteFile(sFileSel);
  DeleteFile(sFile);
end;

procedure ShowFnFile(sPath:string);
var s:string;
    sUni:unicodestring;
begin
  frmMain_sFnPathname.Caption:=sPath; //poznacime cestu pro pripadne ulozeni zmen
  frmMain_bFnEdited.Checked:=false;
  //nacteme soubor
  sUni:=FileToString(sPath); //soubor je v UTF-16
  s:=sUni;
  //prevedeme soubor na ANSI
  if(length(sUni)<2) then begin
    frmMain_lFn.Items.Text:='';
    frmMain_memoLog.Lines.Add(_('ERR: No drafts loaded'));
    EnableButtons();
    exit;
  end;
  if(sUni[1]='G') and (sUni[2]='C') then s:=UtfToAnsi(sUni) //predpokladame UTF-8
  else if(sUni[1]=Chr($ff)) and (sUni[2]=Chr($fe)) then
    s:=UtfToAnsi(CharsetToUtf(sUni,'UTF-16LE'))
  else ShowMessage(_('ERR: wrong file encoding'));
  //najdeme a upravime odradkovani v textu logu (samostatne LF)
  s:=ReplaceString(s,CRLF,'&&_CRLF_&&');
  s:=ReplaceString(s,Chr($0a),' &&_LF_&& ');
  s:=ReplaceString(s,'&&_CRLF_&&',CRLF);
  frmMain_lFn.Items.Text:=s;
  EnableButtons();
end;

procedure GetDrafts;
var sFile,response:string;
begin
  {$ifdef DEBUG_HELPER} LDH('GetDrafts: start'); {$endif}
  if(not SaveFnIfNeed()) then exit; //pokud je treba, ulozime zmeny
  frmMain_memoLog.Lines.Add('GetDrafts: start');
  GeoBusyCaption(_('Getting drafts from a:Drake'));
  GeoBusyProgress(0,3);
  //napred vytvorime adresar
  sFile:=GetPhoneDir()+'\fieldnotes.adrake';
  //podle pozadovaneho typu pouzijeme prislusny pristup
  HttpAsk('GET',GetFceUrl('drafts'),'','',response);
  {$ifdef DEBUG_HELPER} LDH('response='+response+'='); {$endif}
  if(not IsConnected(response)) then frmMain_memoLog.Lines.Add('GetDrafts: ERR')
  else begin
    StringToFile(response,sFile);
    GeoBusyKind(_('Done'));
    frmMain_memoLog.Lines.Add('GetDrafts: ok');
    ShowFnFile(sFile);            //zobrazime soubor v seznamu
  end;
  GeoBusyProgress(0,3);
end;

// Posle fielnotes.txt jako soubor pripojeny k POST pozadavku, dat ho primo jako POST data nejde
// nanoHTTPD pobere jen necelych 16 kb
procedure SendDrafts;
var s,response,sFile,sTextToSend: String;
begin
  {$ifdef DEBUG_HELPER} LDH('SendDrafts: start'); {$endif}
  frmMain_memoLog.Lines.Add('SendDrafts: start');
  if(SaveFnIfNeed()=false) then exit; //preruseno uzivatelem
  GeoBusyCaption(_('Sending drafts to a:Drake'));
  GeoBusyProgress(0,3);
  sFile:=frmMain_sFnPathname.Caption;
  if(not FileExists(sFile)) then begin
    ShowMessage(_('ERR: File to send not found!')+CRLF+CRLF+sFile);
    exit;
  end;
  GeoBusyKind(_('Transfer ...'));
  //odstranime informaci o typu kese, kterou a:Drake neumi zatim parsovat
  sTextToSend:=RegexReplace('(?m),[A-Z]$',FileToString(sFile),'',false);
  {$ifdef DEBUG_HELPER} LDH('SendDrafts: odesilam: '+CRLF+sTextToSend); {$endif}
  HttpAsk('POST',
          GetFceUrl('drafts'),
          'multipart/form-data; boundary=#a1b2c3#',
          '--#a1b2c3#' + CRLF +
          'Content-disposition: form-data; name="drafts"' + CRLF + CRLF +
          sTextToSend + CRLF +
          '--#a1b2c3#',
          response);
  //odpovedi je seznam kesi a jejich WP (GC kod=jmeno) (nebo jen zmenenych?)
  frmMain_memoLog.Lines.Add(UtfToAnsi(LOG_TAB+'response: '+(response)));
  if(not IsConnected(response)) then frmMain_memoLog.Lines.Add('SendDrafts: ERR')
  else begin
    //pokud je potreba, dame prikaz k odeslani na web
    if(frmMain_bFnToGC.Checked) then begin
      if(frmMain_bFnPublish.Checked) then s:=GetFceUrl('drafts/publish')
      else s:=GetFceUrl('drafts/send');
      if(frmMain_bFnKeep.Checked) then s:=s+'/keep';
      frmMain_memoLog.Lines.Add(LOG_TAB+s);
      HttpAsk('GET',s,'','',response);
      if(not IsConnected(response)) then frmMain_memoLog.Lines.Add('SendDrafts: ERR');
    end;
    if(response<>'') then begin
      GeoBusyKind(_('Done'));
      frmMain_memoLog.Lines.Add('SendDrafts: ok');
    end;
  end;
  GeoBusyProgress(0,3);
end;

function GetRewriteWPs(sGpx:string):string;  
//z GPX souboru zjisti seznam WP, ktere maji priznak "Neprepisovat"
//vraci seznam WPT kodu (prefix+kod kese) ve formatu pro SQL frazi IN
var s,sWpts,sSql,sGcCode:string;
    aList:TStringList;
    nLen,iPos,iPosWpt:integer;
    nTickStart,nTickParse,nTickEnd:integer;
    bWpt:boolean;
begin
  {$ifdef DEBUG_HELPER} LDH('zjistuji seznam WP s priznakem Neprepisovat'); {$endif}
  frmMain_memoLog.Lines.Add(LOG_TAB+_('List of WPs marked as "do not rewrite on import"'));
  GeoBusyKind(_('Getting WP list to force rewrite...'));
  GeoBusyProgress(0,100);
  nLen:=Length(sGpx);
  nTickStart:=GetTick();
  while(sGpx<>'') do begin  //parsovanim ziskame seznam ID+PrefixWP
  {$ifdef DEBUG_HELPER} LDH('...'+IntToStr(Round((100*(nLen-Length(sGpx)))/nLen))+' %'); {$endif}
    GeoBusyProgress(Round((100*(nLen-Length(sGpx)))/nLen),100);
    Fetch(sGpx,'<name>');
    iPos:=Pos('</name>',sGpx);   //ziskame kod bodu nebo WP
    if(iPos<1) then break;       //konec parsovani
    s:=Copy(sGpx,1,iPos-1); 
    //overime, zda jde o waypoint nebo o rodicovsky bod
    //pozname to podle <type>Waypoint...</type> nebo <type>Geocache...</type> 
    iPosWpt:=Pos('</wpt>',sGpx);
    iPos:=Pos('<type>Waypoint',sGpx);
    bWpt:=((iPos>0) and (iPos<iPosWpt));
    //predpokladam, ze vzdy je poradi rodicovsky bod a za nim jeho WP (u a:Drake to plati),
    //protoze jinak nemam sanci zjistit prefix rodicovskeho bodu
    if(bWpt) then sWpts:=sWpts+CRLF+sGcCode+Copy(s,1,2) //pridame rodicovsky bod a prefix waypointu
    else sGcCode:=s;       //zapamatujeme si kod rodicovskeho bodu
    {$ifdef DEBUG_HELPER} LDH('name='+s+', bWpt='+IntToStr(bWpt as integer)
      +', Len='+IntToStr(length(sGpx))+', proc='+IntToStr(Round((100*(nLen-Length(sGpx)))/nLen))
      //+', sWpts='+sWpts
      ); {$endif}
  end;
  nTickParse:=GetTick();
  sWpts:='"'+ReplaceString(Trim(sWpts),CRLF,'","')+'"'; //prevedeme do formatu pro SQL frazi IN
  {$ifdef DEBUG_HELPER} LDH('sWpts='+sWpts); {$endif}
  sSql:='SELECT id||prefixid FROM waypoint WHERE (flag & 1)=0 AND id||prefixid IN ('+sWpts+')'; 
  {$ifdef DEBUG_HELPER} LDH('sSql='+sSql); {$endif}
  Result:='';
  aList:=TStringList.Create();
  try
    GEOGET_DB.GetTableStrings(sSql,aList);
    Result:='"'+ReplaceString(Trim(aList.Text),CRLF,'","')+'"';
  finally
    aList.Free();
  end;
  nTickEnd:=GetTick();
  {$ifdef DEBUG_HELPER} LDH('Potrebne casy na zpracovani:'
    +' Parsovani GPX: '+IntToStr(nTickParse-nTickStart)+' ms'
    //+', Parsovani + necteni WP z databaze: '+IntToStr(nTickParse-nTickStart)
    +', Parsovani + zjisteni seznamu WP z databaze: '+IntToStr(nTickEnd-nTickStart)+' ms'
    ); {$endif}
end;

procedure SetRewriteWPs(sWpts:string);     //vsem WP v seznamu nastavi priznak Neprepisovat (bit 0=0)
var sSql:string;
begin
  sSql:='UPDATE waypoint SET flag=(flag & 0x7ffffffffffffffe) WHERE id||prefixid IN ('+sWpts+')';
  GEOGET_DB.ExecSQL(sSql); 
end;

procedure ResetRewriteWPs(sWpts:string);     //vsem WP v seznamu zrusi priznak Neprepisovat (bit 0=1)
var sSql:string;
begin
  sSql:='UPDATE waypoint SET flag=(flag | 1) WHERE id||prefixid IN ('+sWpts+')';
  GEOGET_DB.ExecSQL(sSql); 
end;

function RewriteWarn(bVynutit:boolean):boolean;     //vraci true, pokud prepisovat WP
begin
  Result:=((frmMain_bRewriteWP.Checked) or (bVynutit));
  //pokud dosud nebylo zobrazeno varovani, zobrazime
  if(Result) and (frmMain_bWarnRewriteWP.Checked) then begin
    Result:=(MessBox(_('WARNING!')+CRLF+CRLF
       +_('You have enabled force rewrite waypoints marked as "do not rewrite on import".')
       +' '+_('This can cause data loss when overwriting these waypoints.')+CRLF+CRLF
       +_('Prevent overwriting these waypoints?')+CRLF+CRLF
       ,_('WARNING - waypoint overwriting'), 4 {Yes/No})  =7); //jedine kdyz je Ne, povolime prepis
    frmMain_bWarnRewriteWP.Checked:=false; //priste varovani nezobrazovat
    frmMain_bRewriteWP.Checked:=Result;
  end;
end;

procedure bRewriteWPOnClick(Sender: TObject);
begin
  frmMain_bWarnRewriteWP.Checked:=true;
  RewriteWarn(false);
end;

procedure GpxImport(bRewriteWP:boolean; sFile:string); //import GPX souboru s moznosti prepsat neprepisovatelne WP
//bRewriteWP - prikazuje improtovat WP i v pripade, ze v geogeti databazi
//maji nastaven priznak "Neprepisovat pri importu"
var sRewriteWPs:string;
begin
  {$ifdef DEBUG_HELPER} LDH('   '+'GpxImport - start'); {$endif}
  //pokud maji byt prepsany vsechny WP, zjiskame jejich seznam
  if(bRewriteWP) then begin
    if(RewriteWarn(false)) then begin
      sRewriteWPs:=GetRewriteWPs(FileToString(sFile));
      //{$ifdef DEBUG_HELPER} LDH('sRewriteWPs='+sRewriteWPs); {$endif}
      ResetRewriteWPs(sRewriteWPs);
    end else bRewriteWP:=false;
  end;
  frmMain_memoLog.Lines.Add(LOG_TAB+_('GpxImport: start'));
  GeoImportBegin;
  GeoImportFile(sFile);
  //vratime priznak Neprepisovat (nastavit bit 0=0)
  //to je asi zbytecne, nechame priznak s importu
  // if(bRewriteWP) then setRewriteWPs(sRewriteWPs);
  GeoImportEnd;
  GeoBusyKind(LOG_TAB+'GpxImport: ok');
end;

procedure GcImport(bRewriteWP:boolean);
var response,sCache,sUrl,sFile:string;
begin
  if(not IsIp(false)) then begin
    frmMain_memoLog.Lines.Add('GcImport: '+_('ERR: missing IP, not connected'));
    exit;
  end;
  frmMain_memoLog.Lines.Add('GcImport: start');
  GeoBusyStart;
  GeoBusyCaption(_('Importing caches from a:Drake'));
  GeoBusyProgress(0,3);
  GeoBusyKind(_('Preparing list of caches...'));
  if(frmMain_bGcCodeView.Checked) then begin      //vsechny kese v okne GG
    sFile:=GetPhoneDir()+'\tmp.ggt';
    GeoListSave(sFile);
    sCache:=ReplaceString(Trim(FileToString(sFile)),CRLF,',');
    DeleteFile(sFile);
    if(sCache='') then begin
      ShowMessage(_('ERR: No caches in GeoGet''s list'));
      exit;
    end;
  end;
  if(frmMain_bGcCodeSel.Checked) then begin      //vybrane kese v okne GG
    sFile:=GetPhoneDir()+'\tmp.ggt';
    sCache:=ReplaceString(GetListSelected(sFile),CRLF,',');
    DeleteFile(sFile);
  end;
  if(frmMain_bGcCodeFN.Checked) then begin      //kese, ktere jsou ve FN
    sUrl:=GetFceUrl('drafts');        //zislam FN a z toho seznam kesi
    sCache:='';
    frmMain_memoLog.Lines.Add(LOG_TAB+_('getting list of caches from drafts'));
    if(HttpAsk('GET', sUrl, '', '', response)) then begin
      if(IsConnected(response)) then begin
        while (response<>'') do begin
          sCache:=sCache+CRLF+Fetch(response,',');
          Fetch(response,CRLF);
        end;
        sCache:=ReplaceString(Trim(sCache),CRLF,',');;
        frmMain_memoLog.Lines.Add(LOG_TAB+_('List of caches:')+' '+sCache);
      end;
    end;
  end;
  if(frmMain_bGcCodeID.Checked) then begin      //kes se zadanym GC kodem nebo kody oddelene carkou
    sCache:=frmMain_eGcCode.Text;
  end;
  if(sCache='') then begin
    frmMain_memoLog.Lines.Add('GcImport: '+_('ERR: list of caches is empty'));
    exit;
  end;
  //if(Pos(',',sCache)>1) then begin
  //  sUrl:=_('ERR: pozadavek na import vice kesi, importovat lze jen zatim jednu kes.');  //##_EN_##
  //  frmMain_memoLog.Lines.Add(LOG_TAB+sUrl);
  //  ShowMessage('GcImport: '+sUrl);
  //  exit;
  //end;
  sCache:='('''+sCache+''')';
  sUrl:=GetFceUrl('cache'+sCache);
  sFile:=GetPhoneDir()+'\Tmp.gpx';
  GeoBusyKind(_('Getting GPX ...'));
  if(HttpAsk('GET', sUrl, '', '', response)) then begin
    if(IsConnected(response)) then begin
      StringToFile(response,sFile);
      response:='';
      frmMain_memoLog.Lines.Add(LOG_TAB+_('GPX loaded'));
      GpxImport(bRewriteWP,sFile);
      frmMain_memoLog.Lines.Add('GcImport: ok');
    end;
  end
  else begin
    if(IsConnected(response)) then begin
      frmMain_memoLog.Lines.Add('GcImport: ERR - '+response);
      GeoBusyKind('Error');
    end;
  end;
  GeoBusyProgress(0,3);
end;

procedure GetAttacheFiles(sCaches:string); //nacte soubory priloh k uvedenym kesim
var sDev,sDir,sId,sDirCache,s,sFilename:string;
    sDirSrcUni,sDirTrgUni:unicodestring;
    i:integer;
begin
  if(not IsMtp(false)) then exit;
  sDir:=frmMain_sMtpPath.Caption;
  sDev:=Fetch(sDir,':');
  ML_SetDeviceName(sDev);
  while(sCaches<>'') do begin
    sId:=Fetch(sCaches,CRLF);
    frmMain_memoLog.Lines.Add(LOG_TAB+'GetAttacheFiles: '+sId);
    sDirCache:='/attach/'+sId[Length(sId)]+'/'+sId;
    {$ifdef DEBUG_HELPER} LDH('Stazeni priloh pro kes: '+sId+' ('+sDirCache+')'); {$endif}
    GeoBusyKind(_('Downloading cache attachments')+': '+sId+'...');
    sDirSrcUni:=sDir+sDirCache;
    s:=ML_Dir(sDirSrcUni);
    {$ifdef DEBUG_HELPER} LDH('Obsah adresare: '+sDirSrcUni+CRLF+s+ML_GetErrorMessage()); {$endif}
{ $define CopyAsDir}
{$ifdef CopyAsDir}  //kopirovat adresar jako celek
    if(ML_Exists(sDirSrcUni)>0) then begin //adresar s prilohami existuje, stahneme jej
      sDirTrgUni:=(GEOGET_DATADIR+ReplaceString(sDirCache,'/','\'));
      ForceDirectories(sDirTrgUni); //zakladni adresar, kam se kopiruje, musi existovat
      i:=ML_GetDir(sDirSrcUni,'*',sDirTrgUni,true,true); //rekurzivne a prepsat
      {$ifdef DEBUG_HELPER}
        LDH('Kopirovani adresare (jako adresar): '+sDirCache+', vysledek='+IntToStr(i));
        if(i<0) then LDH('ERR: '+ML_GetErrorMessage());
      {$endif}
    end;
{$else}  //kopirovat adresar po jednotlivych souborech
    if(ML_Exists(sDirSrcUni)>0) then begin //adresar s prilohami existuje, stahneme jej
      sDirTrgUni:=(GEOGET_DATADIR+ReplaceString(sDirCache,'/','\'));
      ForceDirectories(sDirTrgUni); //vytvorime adresar, pokud neexistuje
      {$ifdef DEBUG_HELPER} LDH('Kopirovani adresare (po souborech): '+sDirSrcUni+' do '+sDirTrgUni); {$endif}
      while(s<>'') do begin
        sFileName:=Fetch(s,CRLF);
        i:=ML_GetFile(sDirSrcUni+'/'+sFileName,sDirTrgUni+'\'+sFileName,true); //prepsat
        //i:=ML_GetFile(sDirSrcUni+'/'+sFileName,'g:/Tmp/xx.jpg',true); //prepsat
        {$ifdef DEBUG_HELPER}
          LDH('kopirovani: '+sFilename+', vysledek='+IntToStr(i));
          if(i<0) then LDH('ERR: '+ML_GetErrorMessage());
        {$endif}
      end;
    end
    else begin
      {$ifdef DEBUG_HELPER} LDH('Preskoceno, neexistuje adresar: '+sDir+sDirCache+')'); {$endif}
    end;
{$endif}
  end;
end;

procedure GetLastUpd(sMode:string); //co s vysledkem udelat: LIST/GG/IMPORT
var response,s,sDate,sFormat,sUrl,sFile,sSegment,sChanges:string;
    //aList:TStringList;
    {nRow,}i:integer;
begin
  if(not IsIp(false)) then begin
    frmMain_memoLog.Lines.Add('GetLastUpd: '+_('ERR: missing IP, not connected'));
    exit;
  end;
  {$ifdef DEBUG_HELPER} LDH('GetLastUpd: start ('+sMode+')'); {$endif}
  //pokud maji byt stazeny jen prilohy a neni MTP, konec
  if(not IsMtp(false)) and (frmMain_rCachesAttach.ItemIndex=2) then begin
    exit;
  end;
  frmMain_memoLog.Lines.Add(LOG_TAB+'... '+_('please wait, loading may take a while')+')');
  sDate:=DateToInt(frmMain_dtFrom.Date);
  {if(sDate<>DateToInt(frmMain_dtTo.Date)) then} sDate:=sDate+'-'+DateToInt(frmMain_dtTo.Date);
  sDate:='('''+sDate+''')';
  case sMode of
  'LIST': sFormat:='ggt';
  'GG': sFormat:='ggt';
  'IMPORT': sFormat:='gpx';
  end;
  GeoBusyKind('GetLastUpd - '+sMode);
  sUrl:=GetFceUrl('lastUpd'+sDate+'/'+sFormat);
  sFile:=GetPhoneDir()+'\LastUpd.'+sFormat;
  //nastavime zesnam typu zmen, ktere jsou zajimave
  sChanges:='';
  if(frmMain_lChangeTypes.Selected[0]<>true) then begin
    for i:=1 to frmMain_lChangeTypes.Items.Count-1 do begin
      if(frmMain_lChangeTypes.Selected[i]=true) then begin
        s:=frmMain_lChangeTypes.Items[i];
        sChanges:=sChanges+UpperCase(Fetch(s,'-'))+CRLF;
      end;
    end;
    sChanges:='/types('+ReplaceString(Trim(sChanges),CRLF,',')+')';
    sUrl:=sUrl+sChanges;
  end;
  //pokud je treba, doplnime segment s offsetem a poctem
  if(frmMain_eOffsetLastUpd.Text='') then frmMain_eOffsetLastUpd.Text:='0';
  if(frmMain_eCountLastUpd.Text='') then frmMain_eCountLastUpd.Text:='0';
  if(frmMain_eCountLastUpd.Text<>'0') then begin
    sSegment:='/segment('''+frmMain_eOffsetLastUpd.Text+',';
    if(frmMain_eCountLastUpd.Text='0') then sSegment:=sSegment+'9999'
    else sSegment:=sSegment+frmMain_eCountLastUpd.Text;
    sSegment:=sSegment+''')';
    sUrl:=sUrl+sSegment;
  end
  else begin
    frmMain_memoLog.Lines.Add('GetLastUpd: '+_('ERR: number of caches set to 0'));
    exit;
  end;
  //{$ifdef DEBUG_HELPER} LDH('sUrl: '+sUrl); {$endif}
  GeoBusyKind('GetLastUpd - getting data from a:Drake');
  HttpAsk('GET', sUrl, '', '', response);
  if(IsConnected(response)) then begin
    response:=Trim(response); //vyhazeme prazdne radky na konci
    StringToFile(response,sFile);
    //zjistit pocet kesi
    //aList:=TStringList.Create();
    //try
    //  aList.LoadFromFile(sFile);
    //  nRow:=aList.Count;
    //  //{$ifdef DEBUG_HELPER} LDH('LastUpd: '+IntToStr(nRow)+' radku'+CRLF+aList.Text); {$endif}
    //finally
    //  aList.Free();
    //end;
    case sMode of
    'LIST': frmMain_memoLog.Lines.Add(LOG_TAB+'response: '+response);
    'GG': begin
            GeoListClear();
            GeoListFileAdd(sFile);
            ShowMessage(_('Caches added to GeoGet list. It will be shown after plugin ends.'));
          end;
    'IMPORT': GpxImport(frmMain_bRewriteWP.checked,sFile);
    end;
    //pokud je treba jeste stahnout prilohy, stahneme je
    {$ifdef DEBUG_HELPER} LDH('LastUpd: sMode='+sMode+', ItemIndex='+IntToStr(frmMain_rCachesAttach.ItemIndex)); {$endif}
    if(IsMtp(false)) and (frmMain_rCachesAttach.ItemIndex=1) then begin
      if(sMode='IMPORT') then response:=Trim(FileToString(GEOGET_DATADIR+'\LastImport.ggt'));
      GetAttacheFiles(response);
    end;
    //{$ifdef DEBUG_HELPER} LDH('LastUpd: Hotovo, '+IntToStr(nRow)+' radku'); {$endif}
    frmMain_memoLog.Lines.Add('GetLastUpd: ok');
  end;
end;

procedure butGetIniOnClick(Sender: TObject);
var response: String;
begin
  frmMain_memoLog.Lines.Add('GetIni: start');
  if(IsIp(true)) then begin
    HttpAsk('GET', GetFceUrl('info'), '', '', response);
    if(IsConnected(response)) then begin
      StringToFile(response,GetPhoneDir()+'\adrake.ini');
      frmMain_memoLog.Lines.Add('GetIni: ok');
    end;
  end;
end;

