var aMap:T_MAP; //deklarace pole pro vsechny mapy

procedure EnableMapButtons;
var bMap,bMapSel:boolean;
begin
  bMap:=(frmMain_lMaps.Items.Count>0);
  bMapSel:=(frmMain_lMaps.ItemIndex>=0);
  frmMain_rMapType.Enabled:=bMapSel;
  frmMain_butSendMapCfg.Enabled:=(bMap) and (IsIp(false));
  frmMain_butMapUp.Enabled:=(frmMain_lMaps.ItemIndex>=1);
  frmMain_butMapDown.Enabled:=((bMapSel) and (frmMain_lMaps.ItemIndex+1<frmMain_lMaps.Items.Count));
  frmMain_butMapAdd.Enabled:=((bMap) and (aMap.nMaps<MAX_MAPS));
  frmMain_butMapFromGG.Enabled:=((bMap) and (aMap.nMaps<MAX_MAPS));
  frmMain_butMapDel.Enabled:=bMapSel;
  //mazani dat je mozne jen pro bitmapove mapy (typ google)
  frmMain_butMapDelData.Enabled:=((IsMtp(false)) and (bMapSel) and (frmMain_rMapType.ItemIndex=0));
  frmMain_butMapForgeFileToAD.Enabled:=((IsMtp(false)) and (frmMain_eMapForgeFileLocal.Text<>'') and (frmMain_eMapDir.Text<>''));
  frmMain_butMapForgeThemeToAD.Enabled:=((IsMtp(false)) and (frmMain_eThemeDirLocal.Text<>'') and (frmMain_eThemeDir.Text<>''));
end;

procedure ParseMapType(sNameMapSource:string;eType:T_MAPTYPE_ENUM; eStorage:T_MAPSTORAGE_ENUM; var sXml:string);
var eMode:T_MAPMODE_ENUM;
    sName,sFile,sTheme,sUrl,sSubdomain,sDefaultZoom,sMinZoom,sMaxAvailZoom,sMaxZoom:string;
begin
  if(aMap.nMaps=MAX_MAPS) then begin
    sXml:='';
    exit;
  end;
  case Fetch(sXml,'"') of
    'basic': eMode:=E_BASIC;
    'overlay': eMode:=E_OVERLAY;
    else eMode:=E_MODE_UNKNOWN;
  end;
  Fetch(sXml,'<name>'); sName:=Fetch(sXml,'</name>');
  Fetch(sXml,'<file>'); sFile:=Fetch(sXml,'</file>');
  //if(eType=E_MAPSFORGE) then begin
  //theme je nepovinne, takze jen kdyz je k dispozici
  if(Pos('<theme>',sXml)>0) then begin
     Fetch(sXml,'<theme>'); sTheme:=Fetch(sXml,'</theme>');
  end;
  Fetch(sXml,'<url>'); sUrl:=Fetch(sXml,'</url>');
  Fetch(sXml,'<subdomain>'); sSubdomain:=Fetch(sXml,'</subdomain>');
  Fetch(sXml,'<defaultZoom>'); sDefaultZoom:=Fetch(sXml,'</defaultZoom>');
  Fetch(sXml,'<minZoom>'); sMinZoom:=Fetch(sXml,'</minZoom>');
  Fetch(sXml,'<maxAvailZoom>'); sMaxAvailZoom:=Fetch(sXml,'</maxAvailZoom>');
  Fetch(sXml,'<maxZoom>'); sMaxZoom:=Fetch(sXml,'</maxZoom>');
  if(sName='') then exit;
  aMap.aMap[aMap.nMaps].eType:=eType;
  aMap.aMap[aMap.nMaps].sMapSourceName:=sNameMapSource;
  aMap.aMap[aMap.nMaps].eStorage:=eStorage;
  aMap.aMap[aMap.nMaps].eMode:=eMode;
  aMap.aMap[aMap.nMaps].sName:=sName;
  aMap.aMap[aMap.nMaps].sFile:=sFile;
  aMap.aMap[aMap.nMaps].sTheme:=sTheme;
  aMap.aMap[aMap.nMaps].sUrl:=sUrl;
  aMap.aMap[aMap.nMaps].sSubdomain:=sSubdomain;
  aMap.aMap[aMap.nMaps].sDefaultZoom:=sDefaultZoom;
  aMap.aMap[aMap.nMaps].sMinZoom:=sMinZoom;
  aMap.aMap[aMap.nMaps].sMaxAvailZoom:=sMaxAvailZoom;
  aMap.aMap[aMap.nMaps].sMaxZoom:=sMaxZoom;
  aMap.aMap[aMap.nMaps].sLocalFile:='';
  Inc(aMap.nMaps);
end;

procedure ParseMapSource(sXml:string);
var eType:T_MAPTYPE_ENUM;
    eStorage:T_MAPSTORAGE_ENUM;
    sNameMapSource:string;
    sMapType:string;
begin
  Fetch(sXml,'<type>');
  case Fetch(sXml,'</type>') of
    'Google': eType:=E_GOOGLE;
    'MapsForge': eType:=E_MAPSFORGE;
    else eType:=E_TYPE_UNKNOWN;
  end;
  Fetch(sXml,'<name>');  sNameMapSource:=Fetch(sXml,'</name>');
  Fetch(sXml,'<storage>');
  case Fetch(sXml,'</storage>') of
    'database': eStorage:=E_DATABASE;
    else eStorage:=E_STORAGE_UNKNOWN;
  end;
  while ((sXml<>'') and (aMap.nMaps<MAX_MAPS)) do begin
    Fetch(sXml,'<MapType mode="');
    sMapType:=Fetch(sXml,'</MapType>');
    if(sMapType<>'') then ParseMapType(sNameMapSource,eType,eStorage,sMapType);
  end;
end;

function ParseMapConfig(sXml:string):boolean; //parsuje XML definici do struktury
var sMapSource:string;
begin
  Result:=true;
  aMap.nMaps:=0;
  while((sXml<>'') and (aMap.nMaps<MAX_MAPS)) do begin
    Fetch(sXml,'<MapSource>');
    sMapSource:=Fetch(sXml,'</MapSource>');
    if(sMapSource<>'') then ParseMapSource(sMapSource);
  end;
  if(aMap.nMaps=MAX_MAPS) then begin
    ShowMessage(_('Maximum of loaded maps reached while loading. Some maps may not be displayed.'));
  end;
end;

procedure ShowMapPanel;
begin
  frmMain_pMapForgeEdit.Visible:=(frmMain_rMapType.ItemIndex=1);
  frmMain_pMapBmpEdit.Visible:=(frmMain_rMapType.ItemIndex=0);
end;

procedure GetMapDir;
var ini:TMemIniFile;
    sPhone:string;
begin
  sPhone:=GetPhoneName();
  //{$ifdef DEBUG_HELPER} LDH('sPhone='+sPhone); {$endif}
  ini:=TMemIniFile.Create(GetMyIni());
  try
    frmMain_eMapDir.Text:=ini.ReadString(sPhone,'OSMdir','');
    frmMain_eThemeDir.Text:=ini.ReadString(sPhone,'OSMthemedir','');
  finally
    ini.Free();
  end;
  frmMain_butMapForgeDirSave.Enabled:=false;
end;

procedure lMapsOnClick(Sender: TObject);
var i:integer;
begin
  i:=frmMain_lMaps.ItemIndex;
  if(i<0) then exit;
  if(aMap.aMap[i].eType=E_GOOGLE) then begin
    frmMain_rMapType.ItemIndex:=0;
    frmMain_eMapBmpGroup.Text:=aMap.aMap[i].sMapSourceName;
    frmMain_eMapBmpName.Text:=aMap.aMap[i].sName;
    if(aMap.aMap[i].eMode=E_OVERLAY) then frmMain_cbMapBmpMode.ItemIndex:=1 else frmMain_cbMapBmpMode.ItemIndex:=0;
    frmMain_eMapBmpFile.Text:=aMap.aMap[i].sFile;
    frmMain_eMapBmpUrl.Text:=aMap.aMap[i].sUrl;
    frmMain_eMapBmpSubdomain.Text:=aMap.aMap[i].sSubdomain;
    frmMain_eMapBmpDefault.Text:=aMap.aMap[i].sDefaultZoom;
    frmMain_eMapBmpMin.Text:=aMap.aMap[i].sMinZoom;
    frmMain_eMapBmpMax.Text:=aMap.aMap[i].sMaxZoom;
    frmMain_butMapBmpOk.Enabled:=true;
    //frmMain_butMapForgeOk.Enabled:=false;
  end
  else begin
    frmMain_rMapType.ItemIndex:=1;
    frmMain_eMapDir.Text:=aMap.sMapDir;
    frmMain_eMapForgeName.Text:=aMap.aMap[i].sName;
    frmMain_eMapForgeFile.Text:=aMap.aMap[i].sFile;
    frmMain_eMapForgeTheme.Text:=aMap.aMap[i].sTheme;
    frmMain_eMapForgeDefault.Text:=aMap.aMap[i].sDefaultZoom;
    frmMain_eMapForgeMin.Text:=aMap.aMap[i].sMinZoom;
    frmMain_eMapForgeMax.Text:=aMap.aMap[i].sMaxZoom;
    frmMain_butMapBmpOk.Enabled:=false;
    //frmMain_butMapForgeOk.Enabled:=true;
    frmMain_eMapForgeFileLocal.Text:=aMap.aMap[i].sLocalFile;
  end;
  ShowMapPanel();
  EnableMapButtons();
  GetMapDir();
end;

procedure ShowMaps;
var s2,s1:string;
    i:integer;
  {$define MAPS_GROUP_NUMBERS}
  {$ifdef MAPS_GROUP_NUMBERS}
    igrp:integer;
  {$endif}
begin
  frmMain_lMaps.Items.Text:=''; //vymazeme stavajici seznam
  //mapy pratrici do stejne skupiny oznacime na zacatku stejnym znakem
  //stridame * a #
  //!!! mozna by bylo lepsi pouzit cisla skupiny !!!
  //zobrazime jmena vsech map
  for i:=0 to aMap.nMaps-1 do begin
    s2:='';
    if(i=0) then begin
     {$ifdef MAPS_GROUP_NUMBERS}
     igrp:=1;
     {$else}
     s1:='*';
     {$endif}
    end
    else begin
      if(aMap.aMap[i].sMapSourceName<>aMap.aMap[i-1].sMapSourceName)
        {$ifdef MAPS_GROUP_NUMBERS} or (aMap.aMap[i].eType=E_MAPSFORGE) {$endif}
        then begin
       {$ifdef MAPS_GROUP_NUMBERS}
       Inc(igrp);
       {$else}
       if(s1[1]='*') then s1:='#' else s1:='*'; //zmenime uvodni znak
       {$endif}
      end;
    end;
    {$ifdef MAPS_GROUP_NUMBERS}
    s1:=FormatFloat('0#',igrp); //cislo skupiny prevedeme na string
    {$else}
    s1:=s1[1]; //nechame jen 1. znak (pro pripad, ze drive byl overlay)
    if(aMap.aMap[i].eType=E_MAPSFORGE) then s1:='  '; //vektorove mapy nemaji skupiny
    {$endif}
    s1:=s1+' '; //oddelime priznak stejne skupiny od jmena mapy
    if(aMap.aMap[i].eMode=E_OVERLAY) then begin s1:=s1+'   '; s2:=' (overlay)'; end;
    if(aMap.aMap[i].eMode=E_MODE_UNKNOWN) then s2:=' (???)';
    frmMain_lMaps.Items.Add(s1+aMap.aMap[i].sName+s2);
  end;
end;

procedure RefreshMaps;
var i:integer;
begin
  i:=frmMain_lMaps.ItemIndex;
  ShowMaps();
  frmMain_lMaps.ItemIndex:=i;
end;

procedure SaveMapConfig(sPathname: string);
var sXml,sType,sMode,sStorage,sTheme:string;
    sMapSourceName:string;
    i:integer;
begin
  frmMain_butMapSave.Enabled:=false;
  sXml:='<aDrake>'+CRLF;
  for i:=0 to aMap.nMaps-1 do begin
    if(sMapSourceName<>aMap.aMap[i].sMapSourceName) then begin
      case aMap.aMap[i].eType of
      E_GOOGLE: sType:='Google';
      E_MAPSFORGE: sType:='MapsForge';
      else sType:='';
      end;
      case aMap.aMap[i].eStorage of
      E_DATABASE: sStorage:='database';
      else sStorage:='';
      end;
      sMapSourceName:=aMap.aMap[i].sMapSourceName;
      if(Length(sXml)>20) then sXml:=sXml+'  </MapSource>'+CRLF; //ukoncime predchozi zdroj map
      sXml:=sXml+'  <MapSource>'+CRLF
                +'    <type>'+sType+'</type>'+CRLF
                +'    <name>'+AnsiToUtf(sMapSourceName)+'</name>'+CRLF
                +'    <storage>'+sStorage+'</storage>'+CRLF;
    end;
    case aMap.aMap[i].eMode of
    E_BASIC: sMode:='basic';
    E_OVERLAY: sMode:='overlay';
    else sStorage:='';
    end;
    if(aMap.aMap[i].sTheme='') then sTheme:=''
    else sTheme:='      <theme>'+AnsiToUtf(aMap.aMap[i].sTheme)+'</theme>'+CRLF;
    sXml:=sXml+'    <MapType mode="'+AnsiToUtf(sMode)+'">'+CRLF
              +'      <name>'+AnsiToUtf(aMap.aMap[i].sName)+'</name>'+CRLF
              +'      <file>'+AnsiToUtf(aMap.aMap[i].sFile)+'</file>'+CRLF
              +sTheme
              +'      <url>'+AnsiToUtf(aMap.aMap[i].sUrl)+'</url>'+CRLF
              +'      <subdomain>'+AnsiToUtf(aMap.aMap[i].sSubdomain)+'</subdomain>'+CRLF
              +'      <defaultZoom>'+aMap.aMap[i].sDefaultZoom+'</defaultZoom>'+CRLF
              +'      <minZoom>'+aMap.aMap[i].sMinZoom+'</minZoom>'+CRLF
              +'      <maxAvailZoom>'+aMap.aMap[i].sMaxAvailZoom+'</maxAvailZoom>'+CRLF
              +'      <maxZoom>'+aMap.aMap[i].sMaxZoom+'</maxZoom>'+CRLF
              +'    </MapType>'+CRLF;
  end;
  if(Length(sXml)>20) then sXml:=sXml+'  </MapSource>'+CRLF; //ukoncime predchozi zdroj map
  sXml:=sXml+'</aDrake>'+CRLF;
  {$ifdef DEBUG_HELPER} LDH('Zapis XML do souboru: '+sPathname); {$endif}
  StringToFile(sXml,sPathname);
end;

function SaveMapsIfNeed:boolean;  //pokud jsou neulozene zmeny v definici map, opta se a ulozi
var i:integer;   //vraci true, pokud pokracovat, false pokud ma byt funkce, ktera tento dialog vyvolala, prerusena
begin
  Result:=true;
  if(not frmMain_butMapSave.Enabled) then exit;
  i:=MessBox(_('Changes in maps settings are not saved. Save now?'),_('Unsaved changes'),3);
  //2=Cacnel, 6=Yes, 7=No.
  if(i=2) then begin Result:=false; exit; end; //pretusit zpracovani
  if(i=7) then exit; //bez ulozeni
  SaveMapConfig(frmMain_sMapPathname.Caption);
end;

procedure ShowMapCfg(sXml:string);
begin
  if(not SaveMapsIfNeed()) then exit; //pokud je treba, ulozime zmeny, pokud je zadano, ukoncime se
  frmMain_butMapSave.Enabled:=false;
  sXml:=UtfToAnsi(sXml); //prevedeme na ANSI
  ParseMapConfig(sXml);
  ShowMaps();
  EnableMapButtons();
end;

procedure GetMapCfg;
var response: String;
begin
  frmMain_memoLog.Lines.Add('GetMapCfg: start');
  if(IsIp(true)) then begin
    HttpAsk('GET', GetFceUrl('mapConfig'), '', '', response);
    if(IsConnected(response)) then begin
      //frmMain_memoLog.Lines.Add(LOG_TAB+'response: '+response);
      StringToFile(response,GetPhoneDir()+'\mapConfig.xml');
      frmMain_memoLog.Lines.Add('GetMapCfg: ok');
      ShowMapCfg(response);
      frmMain_sMapPathname.Caption:=GetPhoneDir()+'\mapConfig.xml';
    end;
  end;
end;

procedure butMapCfgFromFileOnClick(Sender: TObject);
var sPath:string;
begin
  //rekneme si o soubor a nacteme jej
  if(not OpenDlg(_('Show map settings'), //title
               GetMyDir(),               //InitDir
              'ofFileMustExist,ofHideReadOnly', //options
              _('XML files')+'  (*.xml)|*.xml'              //filtr
              +'|'+_('All files')+'  (*.*)|*.*'
              ,
              sPath)) then exit;
  ShowMapCfg(FileToString(sPath));
  frmMain_sMapPathname.Caption:=sPath;
end;

procedure butMapFromGGOnClick(Sender:TObject);
var s,sName:string;
    i:integer;
begin
  frmGeogetMaps_lGgMaps.Items.Text:=FileToString(GEOGET_DATADIR+'\mapdef\order.txt');
  //jmeno souboru zmenime na jmeno mapy
  for i:=0 to frmGeogetMaps_lGgMaps.Items.Count-1 do begin
    s:=FileToString(GEOGET_DATADIR+'\mapdef\'+frmGeogetMaps_lGgMaps.Items[i]+'.ini');
    Fetch(s,'name=');
    sName:=Fetch(s,CRLF);
    frmGeogetMaps_lGgMaps.Items[i]:=sName+' ('+frmGeogetMaps_lGgMaps.Items[i]+')';
  end;
  frmGeogetMaps.ShowModal();
end;

procedure butGgMapOkOnClick(Sender:TObject); //vlozeni mapy z Geogetu do aDrake
var s,s1,s2:string;
    i,j:integer;
    rMap:T_MAPRECORD;
begin
  i:=frmGeogetMaps_lGgMaps.ItemIndex;
  if(i<0) then exit;
  s:=frmGeogetMaps_lGgMaps.Items[i];
  s1:=Fetch(s,'(');
  s2:=Fetch(s,')');
  s:=FileToString(GEOGET_DATADIR+'\mapdef\'+s2+'.ini');
  rMap.eType:=E_GOOGLE;
  Fetch(s,'name=');  s1:=Fetch(s,CRLF);
  rMap.sMapSourceName:=s2;   //????
  rMap.eStorage:=E_DATABASE;
  rMap.eMode:=E_BASIC;
  rMap.sName:=s1;
  rMap.sFile:=ReplaceString(s2,'_','/');
  rMap.sTheme:='';  //nevyuzito, GG neumi MapsForge mapy
  Fetch(s,'url=');  s1:=Fetch(s,CRLF);
  rMap.sUrl:=s1;
  Fetch(s,'subdomains=');  s1:=Fetch(s,CRLF);
  rMap.sSubdomain:=s1;
  Fetch(s,'minzoom=');  s1:=Fetch(s,CRLF);
  rMap.sMinZoom:=s1;
  Fetch(s,'maxzoom=');  s1:=Fetch(s,CRLF);
  rMap.sMaxZoom:=s1;
  rMap.sMaxAvailZoom:=s1;
  rMap.sDefaultZoom:=IntToStr((StrToInt(rMap.sMinZoom)+StrToInt(rMap.sMaxZoom))/2);
  //pridame mapu a prepiseme tam tuto
  j:=frmMain_lMaps.ItemIndex;
  for i:=aMap.nMaps-1 downto j+1 do begin
    aMap.aMap[i+1]:=aMap.aMap[i];
  end;
  Inc(aMap.nMaps);
  aMap.aMap[j+1]:=rMap;
  ShowMaps();
  frmMain_lMaps.ItemIndex:=j+1;
  lMapsOnClick(nil);
  frmMain_butMapSave.Enabled:=true;
end;

procedure MoveMap(iAdd:integer);
var idx:integer;
    s:string;
    rMap:T_MAPRECORD;
begin
  idx:=frmMain_lMaps.ItemIndex;
  if(idx<0) then exit;
  rMap:=aMap.aMap[idx]; 
  aMap.aMap[idx]:=aMap.aMap[idx+iAdd];  
  aMap.aMap[idx+iAdd]:=rMap;
  s:=frmMain_lMaps.Items[idx];
  frmMain_lMaps.Items[idx]:=frmMain_lMaps.Items[idx+iAdd];
  frmMain_lMaps.Items[idx+iAdd]:=s;
  frmMain_lMaps.ItemIndex:=idx+iAdd;
  lMapsOnClick(nil);
  frmMain_butMapSave.Enabled:=true;
  RefreshMaps(); //aktualizovat seznam map, vcetne cisel skupin
end;

procedure butMapDelOnClick(Sender:TObject); //vymazani mapy
var i,idx:integer;
begin
  idx:=frmMain_lMaps.ItemIndex;
  for i:=idx to aMap.nMaps-2 do begin
    aMap.aMap[i]:=aMap.aMap[i+1];
    frmMain_lMaps.Items[i]:=frmMain_lMaps.Items[i+1];
  end;
  Dec(aMap.nMaps);
  if(idx>aMap.nMaps-1) then idx:=aMap.nMaps-1;
  frmMain_lMaps.ItemIndex:=idx;
  lMapsOnClick(nil);
  frmMain_butMapSave.Enabled:=true;
end;

procedure butMapDelDataOnClick(Sender:TObject); //vymazani ulozenych dlazdic pro mapu
var sFile,sDir,sDev:string;
    //sFileuni,sDiruni,sDevuni:unicodestring;
begin
  if(MessBox(_('Byla zvolena funkce pro vymazani vsech nactenych dlazdic vybrane mapy! Interrupt processing?'),
    _('Smazani nactenych dat mapy'),4)=6) then exit;
  //ShowMessage(_('Funkce zatim neni implementovana.'));   //##_EN_##
  //nacteme polozku dir a pridame za ni .sqlitedb a .sqlitedb-journal, tyto dva soubory smazeme
  sDev:=GetMtpDev();
  sDir:=GetMtpDir()+'/maps';
  sFile:=(aMap.aMap[frmMain_lMaps.ItemIndex].sFile);
  ML_SetDeviceName(sDev);
  {$ifdef DEBUG_HELPER} LDH('  device: '+sDev); {$endif}
  //{$ifdef DEBUG_HELPER} LDH('  sDir: '+sDir); {$endif}
  //{$ifdef DEBUG_HELPER} LDH('  existence sDir: '+IntToStr(ML_Exists(sDir))); {$endif}
  //{$ifdef DEBUG_HELPER} LDH('  sFile: '+sDir+'/'+sFile); {$endif}
  //{$ifdef DEBUG_HELPER} LDH('  existence sFile: '+IntToStr(ML_Exists(sDir+'/'+sFile+'.sqlitedb'))); {$endif}

  frmMain_memoLog.Lines.Add(_('Remove')+' '+sFile);
  sFile:=sFile+'.sqlitedb';
  {$ifdef DEBUG_HELPER} LDH('Mazu mapove dlazdice: '+sDir+'/'+sFile); {$endif}
  ML_DeleteFile(sDir+'/'+sFile);
  {$ifdef DEBUG_HELPER} LDH('  stav: '+ML_GetErrorMessage()); {$endif}
  // //frmMain_memoLog.Lines.Add(LOG_TAB+'sqlitedb '+ML_GetErrorMessage());
  sFile:=sFile+'-journal';
  ML_DeleteFile(sDir+sFile);
  {$ifdef DEBUG_HELPER} LDH('  stav: '+ML_GetErrorMessage()); {$endif}
  // //frmMain_memoLog.Lines.Add(LOG_TAB+'sqlitedb-journal '+ML_GetErrorMessage());
end;

procedure butMapAddOnClick(Sender:TObject); //pridat mapu
var i,idx:integer;
    rMap:T_MAPRECORD;
begin 
  idx:=frmMain_lMaps.ItemIndex;
  //pridame mapu a prepiseme tam tuto
  idx:=frmMain_lMaps.ItemIndex;
  for i:=aMap.nMaps-1 downto idx+1 do begin
    aMap.aMap[i+1]:=aMap.aMap[i];
    frmMain_lMaps.Items[i+1]:=frmMain_lMaps.Items[i];
  end;
  rMap.eType:=E_GOOGLE;
  rMap.sMapSourceName:='osm';
  rMap.eStorage:=E_DATABASE;
  rMap.sName:='new map';
  rMap.sFile:='osm/new_map';
  rMap.sDefaultZoom:='12';
  rMap.sMinZoom:='1';
  rMap.sMaxAvailZoom:='18';
  rMap.sMaxZoom:='18';
  Inc(idx);
  aMap.aMap[idx]:=rMap;
  frmMain_lMaps.Items[idx]:='new map';
  frmMain_lMaps.ItemIndex:=idx;
  Inc(aMap.nMaps);
  lMapsOnClick(nil);
  frmMain_butMapSave.Enabled:=true;
end;

procedure eMapDirOnChange(Sender:TObject); //zmena adresare s OSM mapami v telefonu
begin
  frmMain_butMapForgeDirSave.Enabled:=true;
  EnableMapButtons();
end;

procedure eMapForgeFileLocalOnChange(Sender:TObject); //zmena adresare s OSM mapami v telefonu
begin EnableMapButtons(); end;

procedure butMapForgeDirSaveOnClick(Sender:TObject); //zmena adresare s OSM mapami v telefonu
var ini:TMemIniFile;
    sPhone:string;
begin
  sPhone:=GetPhoneName();
  ini:=TMemIniFile.Create(GetMyIni());
  try
    ini.WriteString(sPhone,'OSMdir',frmMain_eMapDir.Text);
    ini.WriteString(sPhone,'OSMthemedir',frmMain_eThemeDir.Text);
    ini.UpdateFile(); //zapiseme zmeny do souboru
  finally
    ini.Free();
  end;
  frmMain_butMapForgeDirSave.Enabled:=false;
end;

procedure butMapUpOnClick(Sender:TObject); //posun mapy nahoru
begin MoveMap(-1); end;

procedure butMapDownOnClick(Sender:TObject); //posun mapy dolu
begin MoveMap(1); end;

procedure butMapSaveOnClick(Sender:TObject); //ulozeni zmeny do souboru
begin
  SaveMapConfig(frmMain_sMapPathname.Caption);
  frmMain_butMapSave.Enabled:=false;
end;

procedure butSendMapCfgOnClick(Sender:TObject); //odeslani konfigurace do AD
var response:string;
begin
  if(not SaveMapsIfNeed()) then exit; //pokud je treba, ulozime zmeny, pokud je zadano, ukoncime se
  HttpAsk('POST',
          GetFceUrl('uploadfile?done=true'),
          'multipart/form-data; boundary=#a1b2c3#',
          '--#a1b2c3#' + CRLF +
          'Content-disposition: form-data; name="filename"; filename="map-config.xml"' + CRLF +
          'Content-Type: text/xml' + CRLF + CRLF +
          FileToString(frmMain_sMapPathname.Caption) + CRLF +
          '--#a1b2c3#',
          response);
end;

procedure rMapTypeOnClick(Sender: TObject);
var idx:integer;
begin
  idx:=frmMain_lMaps.ItemIndex;
  if(aMap.aMap[idx].eType=E_GOOGLE) and (frmMain_rMapType.ItemIndex=0) then exit;
  if(aMap.aMap[idx].eType=E_MAPSFORGE) and (frmMain_rMapType.ItemIndex=1) then exit;
  if(frmMain_rMapType.ItemIndex=0) then aMap.aMap[idx].eType:=E_GOOGLE
  else aMap.aMap[idx].eType:=E_MAPSFORGE;
  lMapsOnClick(nil);
  frmMain_butMapForgeOK.Enabled:=true;
  frmMain_butMapBmpOK.Enabled:=true;
  frmMain_butMapSave.Enabled:=true;
end;

procedure butMapForgeFileLocalOnClick(Sender: TObject); //vybrat soubor s OSM mapou k odeslani do zarizeni
var sPath:string;
begin
  if(not OpenDlg(_('OSM map file'), //title
               GetMyDir(),               //InitDir
              'ofFileMustExist,ofHideReadOnly', //options
              _('Map files')+'  (*.map)|*.map'              //filtr
              +'|'+_('All files')+'  (*.*)|*.*'
              ,
              sPath)) then exit;
  frmMain_eMapForgeFileLocal.Text:=sPath;
  EnableMapButtons();
end;

procedure SendMapFile;
var sDev,sSrc,sTrg,sSrcOrig,sSrcName,sTrgName:string;    //zapise mapu do zarizeni
    bRename:boolean;
begin
  if(not IsMtp(true)) then exit;
  frmMain_memoLog.Lines.Add('SendMapFile: start');
  sDev:=GetMtpDev();
  {$ifdef DEBUG_HELPER} LDH('DEV name: '+sDev); {$endif}
  //pokud neni jmeno souboru s mapou shodne se jmenem v config souboru,
  //vytvorime pracovni kopii
  //nastaveni cest v eMapForgeFile a eMapDir neni stejne - i kdyz ukazuji na
  //stejne misto, cesty budou ruzne, protoze jedno je pristup pres system,
  //druhe pristup pres MTP
  sTrgName:=RegExSubstitute('(.*/)(.*)',frmMain_eMapForgeFile.Text,'$2');
  sSrcName:=RegExSubstitute('(.*\\)(.*)',frmMain_eMapForgeFileLocal.Text,'$2');
  {$ifdef DEBUG_HELPER} LDH('Jmena souboru: zdrojova mapa='+sSrcName+', cilova mapa='+sTrgName); {$endif}
  bRename:=(UpperCase(sSrcName)<>UpperCase(sTrgName));
  sSrc:=frmMain_eMapForgeFileLocal.Text;
  sSrcOrig:=sSrc;
  sTrg:=frmMain_eMapDir.Text;
  if(bRename) then begin //pracovni kopie souboru
    frmMain_memoLog.Lines.Add(LOG_TAB+_('Creating a working copy of map file'));
    GeoBusyKind(_('Creating a working copy of map file')+' ...');
    GeoBusyProgress(2,4);
    sSrc:=GetMyDir()+'\'+sTrgName;
    CopyFile(sSrcOrig,sSrc);
  end;
  frmMain_memoLog.Lines.Add(LOG_TAB+_('Transferring map file to a:Drake'));
  GeoBusyKind(_('Transferring map file to a:Drake')+' ...');
  GeoBusyProgress(3,4);
  ML_SetDeviceName(sDev);
  {$ifdef DEBUG_HELPER} LDH('Zarizeni vybrano'); {$endif}
  ML_PutFile(sSrc,sTrg,true); //vzdy prepiseme
  if((bRename)) then begin //smazeme pracovni kopii
    GeoBusyProgress(4,4);
    GeoBusyKind(_('Deleting map file working copy')+' ...');
    frmMain_memoLog.Lines.Add(LOG_TAB+_('Deleting map file working copy'));
    {$ifdef DEBUG_HELPER} LDH('Smazat pracovni kopii souboru s mapou'); {$endif}
    DeleteFile(sSrc);
  end;
  GeoBusyKind(_('Done'));
  GeoBusyProgress(0,1);
  frmMain_memoLog.Lines.Add('SendMapFile: ok');
end;

procedure butMapForgeThemeDirLocalOnClick(Sender: TObject); //vybrat adresar s tematem pro OSM mapu
var sPath:string;
begin
  sPath:=SelectDir(GetMyDir(),_('Adresar s mapovym tematem'));  //##_EN_##
  if(sPath='') then exit;
  //bez posledniho znaku
  sPath:=Copy(sPath,1,Length(sPath)-1);
  frmMain_eThemeDirLocal.Text:=sPath;
  EnableMapButtons();
end;

procedure butMapBmpOkOnClick(Sender:TObject); //pouziti zmenene mapy
var i:integer;
begin
  i:=frmMain_lMaps.ItemIndex;
  {$ifdef DEBUG_HELPER} LDH('Ulozeni upravene mapy, index='+IntToStr(i)); {$endif}
  if(i<0) then exit;
  aMap.aMap[i].eType:=E_GOOGLE;
  aMap.aMap[i].sMapSourceName:=frmMain_eMapBmpGroup.Text;
  aMap.aMap[i].sName:=frmMain_eMapBmpName.Text;
  if(frmMain_cbMapBmpMode.ItemIndex=1) then aMap.aMap[i].eMode:=E_OVERLAY
  else aMap.aMap[i].eMode:=E_BASIC;
  aMap.aMap[i].sFile:=frmMain_eMapBmpFile.Text;
  aMap.aMap[i].sUrl:=frmMain_eMapBmpUrl.Text;
  aMap.aMap[i].sSubdomain:=frmMain_eMapBmpSubdomain.Text;
  aMap.aMap[i].sDefaultZoom:=frmMain_eMapBmpDefault.Text;
  aMap.aMap[i].sMinZoom:=frmMain_eMapBmpMin.Text;
  aMap.aMap[i].sMaxZoom:=frmMain_eMapBmpMax.Text;
  RefreshMaps(); //aktualizovat seznam map
  frmMain_butMapSave.Enabled:=true;
end;

procedure butMapForgeOkOnClick(Sender:TObject); //pouziti zmenene mapy
var i:integer;
begin
  i:=frmMain_lMaps.ItemIndex;
  {$ifdef DEBUG_HELPER} LDH('Ulozeni upravene mapy, index='+IntToStr(i)); {$endif}
  if(i<0) then exit;
  aMap.aMap[i].eType:=E_MAPSFORGE;
  aMap.sMapDir:=frmMain_eMapDir.Text;
  aMap.aMap[i].sName:=frmMain_eMapForgeName.Text;
  aMap.aMap[i].sFile:=frmMain_eMapForgeFile.Text;
  aMap.aMap[i].sTheme:=frmMain_eMapForgeTheme.Text;
  aMap.aMap[i].sDefaultZoom:=frmMain_eMapForgeDefault.Text;
  aMap.aMap[i].sMinZoom:=frmMain_eMapForgeMin.Text;
  aMap.aMap[i].sMaxZoom:=frmMain_eMapForgeMax.Text;
  aMap.aMap[i].sLocalFile:=frmMain_eMapForgeFileLocal.Text;
  RefreshMaps(); //aktualizovat seznam map
  frmMain_butMapSave.Enabled:=true;
end;

procedure SendMapTheme;
var sDev,sSrcName,sTrgName:string;    //zapise mapove tama do zarizeni
    i:integer;
begin
  if(not IsMtp(true)) then exit;
  sTrgName:=frmMain_eThemeDir.Text; //tady je adresar nadrizeny vsem tematum
  sSrcName:=frmMain_eThemeDirLocal.Text;
  sTrgName:=sTrgName+'/'+RegexReplace('.*[/\\]',sSrcName,'',false);
  {$ifdef DEBUG_HELPER} LDH('Zdrojovy adresar='+sSrcName+CRLF+'Cilovy adresar='+sTrgName); {$endif}
  //ze zdrojoveho adresare vezmeme posledni adresar a pridame ho k cilovemu
  frmMain_memoLog.Lines.Add('SendMapTheme: start');
//exit;
  sDev:=GetMtpDev();
  {$ifdef DEBUG_HELPER} LDH('DEV name: '+sDev); {$endif}
  //vytvorime adresar, pokud jeste neexistuje, ale jen posledni uroven
  i:=ML_Exists(sTrgName);
  if(i=0) then i:=ML_MkDir(sTrgName,false)
  else i:=0;
  if(i<>0) then begin
    frmMain_memoLog.Lines.Add(LOG_TAB+'ERR: create dir: '+sTrgName);
    frmMain_memoLog.Lines.Add(LOG_TAB+LOG_TAB+ML_GetErrorMessage());
    exit;
  end;
  frmMain_memoLog.Lines.Add(LOG_TAB+_('Transferring theme files to device')); //##_EN_##
  GeoBusyKind(_('Transferring theme file to device')+' ...');                //##_EN_##
  GeoBusyProgress(2,4);
  ML_SetDeviceName(sDev);
  {$ifdef DEBUG_HELPER} LDH('Zarizeni vybrano'); {$endif}
  i:=ML_PutDir(sSrcName,'*',sTrgName,true,true); //vsecho,rekurzivne a existujici prepiseme
  GeoBusyKind(_('Done'));
  GeoBusyProgress(0,1);
  if(i=0) then frmMain_memoLog.Lines.Add('SendMapTheme: ok')
  else frmMain_memoLog.Lines.Add('SendMapTheme: ERR '+ML_GetErrorMessage())
end;
