//funkce pro nastaveni IP adresy a portu pro multicast
procedure SetMulticastParam(str:string);
var s:string;
begin
  s:=str;
  frmConnect_sIp.Caption:=Fetch(s,':');
  frmConnect_sPort.Caption:=Fetch(s,'-');
  frmConnect_sName.Caption:=s;
  frmMain_memoLog.Lines.Add('Multicast: '+frmConnect_sIp.Caption+':'+frmConnect_sPort.Caption);
end;

function GetMulticastParam:string;
begin
  Result:=frmConnect_sIp.Caption+':'+frmConnect_sPort.Caption+' - '+frmConnect_sName.Caption;
end;

procedure butMulticastOnClick(Sender: TObject);
begin
  frmConnect.ShowModal();
end;

procedure butMcUseOnClick(Sender: TObject);
var sOld,s,sFile:string;
begin
  if(frmConnect_lConnect.ItemIndex<0) then exit;
  sOld:=GetMulticastParam();
  SetMulticastParam(frmConnect_lConnect.Items[frmConnect_lConnect.ItemIndex]);
  //nahradime v GgDrake.config.pas puvodni string novym
  sFile:=GetMyDir()+'\GgDrake.config.pas';
  s:=FileToString(sFile);
  s:=ReplaceString(s,sOld,frmConnect_lConnect.Items[frmConnect_lConnect.ItemIndex]);
  StringToFile(s,sFile);
end;

procedure butMcSaveOnClick(Sender: TObject); //ulozi seznam pripojeni do INI souboru
var ini:TMemIniFile;
    s,sIp,sFile:string;
    i:integer;
begin
  //sFile:=GetMyDir()+'\GgDrake.ini';
  sFile:=GetMyIni();
  ini:=TMemIniFile.Create(sFile);
  try
    ini.EraseSection('Multicast'); //napred vymazeme celou sekci
    for i:=0 to frmConnect_lConnect.Items.Count-1 do begin  //pridame vsechny radky
      s:=frmConnect_lConnect.Items[i];
      sIp:=Fetch(s,'-');
      ini.WriteString('Multicast',s,sIp);
    end;
  finally
    ini.UpdateFile(); //zapiseme zmeny do souboru
    ini.Free();
  end;
end;

procedure FillConnects; //naplni seznam pripojeni moznymi pripojenimi z INI souboru
var ini:TMemIniFile;
    s,sName,sFile:string;
    i:integer;
begin
  sFile:=GetMyDir()+'\GgDrake.ini';
  frmConnect_lConnect.Items.Text:='';
  ini:=TMemIniFile.Create(sFile);
  try
    ini.ReadSectionValues('Multicast',frmConnect_lConnect.Items);
    for i:=0 to frmConnect_lConnect.Items.Count-1 do begin
      s:=frmConnect_lConnect.Items[i];
      sName:=Fetch(s,'=');
      s:=s+' - '+sName;
      frmConnect_lConnect.Items[i]:=s;
    end;
  finally
    ini.Free();
  end;
end;

procedure eMcOnChange(Sender: TObject);
begin
  if(frmConnect_lConnect.ItemIndex<0) then exit;
  frmConnect_lConnect.Items[frmConnect_lConnect.ItemIndex]:=
    Trim(frmConnect_eMcIp.Text)+':'+Trim(frmConnect_eMcPort.Text)+' - '+Trim(frmConnect_eMcName.Text);
  frmConnect_butMcSave.Enabled:=true;
end;

procedure lConnectOnClick(Sender: TObject);
var s:string;
    b:boolean;
begin
  b:=frmConnect_butMcSave.Enabled;  //uschovane stav zmen
  s:=frmConnect_lConnect.Items[frmConnect_lConnect.ItemIndex];
  frmConnect_eMcIp.Text:=Fetch(s,':');
  frmConnect_eMcPort.Text:=Fetch(s,'-');
  frmConnect_eMcName.Text:=s;
  frmConnect_butMcSave.Enabled:=b;
end;

procedure butMcAddOnClick(Sender: TObject);
begin
  frmConnect_lConnect.Items.Insert(frmConnect_lConnect.ItemIndex+1,'239.255.255.255:5000 - New');
  frmConnect_lConnect.ItemIndex:=frmConnect_lConnect.ItemIndex+1;
  lConnectOnClick(nil);
  frmConnect_butMcSave.Enabled:=true;
end;

procedure butMcDelOnClick(Sender: TObject);
var i:integer;
begin
  i:=frmConnect_lConnect.ItemIndex;
  if(i<0) then exit;
  frmConnect_lConnect.Items.Delete(i);
  if(i>=frmConnect_lConnect.Items.Count) then i:=frmConnect_lConnect.Items.Count-1;
  frmConnect_lConnect.ItemIndex:=i;
  lConnectOnClick(nil);
  frmConnect_butMcSave.Enabled:=true;
end;

